diff -bruN freeswan-1.9.orig/pluto/spdb.c freeswan-1.9/pluto/spdb.c
--- freeswan-1.9.orig/pluto/spdb.c	Mon Feb 26 13:42:57 2001
+++ freeswan-1.9/pluto/spdb.c	Thu Jun  7 14:33:57 2001
@@ -648,6 +1208,180 @@
     return val;
 }
 
+#ifdef OPENSSL
+struct _trans_node {
+  struct oakley_trans_attrs ta;
+  struct isakmp_transform trans;
+  u_char *attr_start;
+  size_t attr_len;
+  bool elim; /* has this node been eliminated from the selection process */
+  struct _trans_node *next;
+};
+
+typedef struct _trans_node *trans_list;
+
+/* Free a list of Oakley transforms */
+static void
+trans_list_free( trans_list *l )
+{
+  trans_list p;
+
+  if (!l) return;
+  while (*l) {
+    p = *l;
+    *l = p->next;
+    pfree(p->attr_start);
+    pfree(p);
+  }
+}
+
+static void
+trans_list_append(trans_list *l,
+		  struct oakley_trans_attrs *ta,
+		  struct isakmp_transform *trans,
+		  u_char *attr_start,
+		  size_t attr_len) {
+  trans_list p, pp;
+
+  if (!l) return;
+  if ((p = alloc_bytes(sizeof(struct _trans_node),
+		       "transformation node")) == NULL) return;
+  p->ta = *ta;
+  p->trans = *trans;
+  p->attr_len = attr_len;
+  if ((p->attr_start = alloc_bytes(attr_len, "attribute")) == NULL) {
+    pfree(p);
+    return;
+  }
+  memcpy(p->attr_start, attr_start, attr_len);
+  p->elim = FALSE;
+  p->next = NULL;
+  if (*l == NULL) {
+    *l = p;
+  } else {
+    for(pp = *l; pp->next ; pp = pp->next);
+    pp->next = p;
+  }
+}
+
+static bool
+select_trans_candidate(trans_list l,
+		       struct oakley_trans_attrs *ta,
+		       struct isakmp_transform *trans,
+		       u_char **attr_start,
+		       size_t *attr_len,
+		       u_int32_t opts)
+{
+  bool ret = FALSE;
+  trans_list auth[OAKLEY_ELGAMAL_ENC_REV+1], p;
+  uint i, numprefs, pref[10];
+
+  if (!l) {
+    DBG(DBG_PARSING,
+    DBG_log("No candidate transforms to choose from");
+    );
+    return FALSE;
+  }
+
+  if ((!ta) || (!attr_len) || (!trans) || (!attr_start)) {
+    DBG(DBG_PARSING,
+    DBG_log("No space to store selected transform");
+    );
+    return FALSE;
+  }
+
+  /* Separate all elements of the list by authentication method */
+
+  for(i=OAKLEY_PRESHARED_KEY; i<=OAKLEY_ELGAMAL_ENC_REV; i++)
+    auth[i] = NULL;
+  for(p=l; p; p=p->next)
+    if ((p->ta.auth >= OAKLEY_PRESHARED_KEY) &&
+	(p->ta.auth <= OAKLEY_ELGAMAL_ENC_REV )) {
+      trans_list_append(&(auth[p->ta.auth]),
+			&(p->ta),
+			&(p->trans),
+			p->attr_start,
+			p->attr_len);
+    }
+
+  numprefs = 7;
+  pref[numprefs-1] = OAKLEY_PRESHARED_KEY;
+  DBG(DBG_PARSING | DBG_CRYPT,
+  DBG_log("select_trans_candidate: %08x", opts);
+  );
+  if (opts & CERT_OPTION_PK) {
+    if (opts & CERT_OPTION_REV) {
+      DBG(DBG_PARSING | DBG_CRYPT,
+      DBG_log("Preferring revised PK encryption schemes");
+      );
+      pref[0] = OAKLEY_ELGAMAL_ENC_REV;
+      pref[1] = OAKLEY_RSA_ENC_REV;
+      pref[2] = OAKLEY_ELGAMAL_ENC;
+      pref[3] = OAKLEY_RSA_ENC;
+      pref[4] = OAKLEY_RSA_SIG;
+      pref[5] = OAKLEY_DSS_SIG;
+    } else {
+      DBG(DBG_PARSING | DBG_CRYPT,
+      DBG_log("Preferring standard PK encryption schemes");
+      );
+      pref[0] = OAKLEY_ELGAMAL_ENC;
+      pref[1] = OAKLEY_RSA_ENC;
+      pref[2] = OAKLEY_ELGAMAL_ENC_REV;
+      pref[3] = OAKLEY_RSA_ENC_REV;
+      pref[4] = OAKLEY_RSA_SIG;
+      pref[5] = OAKLEY_DSS_SIG;
+    }
+  } else {
+    if (opts & CERT_OPTION_REV) {
+      DBG(DBG_PARSING | DBG_CRYPT,
+      DBG_log("Preferring digisig schemes, then revised pk");
+      );
+      pref[0] = OAKLEY_RSA_SIG;
+      pref[1] = OAKLEY_DSS_SIG;
+      pref[2] = OAKLEY_ELGAMAL_ENC_REV;
+      pref[3] = OAKLEY_RSA_ENC_REV;
+      pref[4] = OAKLEY_ELGAMAL_ENC;
+      pref[5] = OAKLEY_RSA_ENC;
+    } else {
+      DBG(DBG_PARSING | DBG_CRYPT,
+      DBG_log("Preferring digisig schemes, then standard pk");
+      );
+      pref[0] = OAKLEY_RSA_SIG;
+      pref[1] = OAKLEY_DSS_SIG;
+      pref[2] = OAKLEY_ELGAMAL_ENC;
+      pref[3] = OAKLEY_RSA_ENC;
+      pref[4] = OAKLEY_ELGAMAL_ENC_REV;
+      pref[5] = OAKLEY_RSA_ENC_REV;
+    }
+  }
+
+  for(i=0; ((i<numprefs) && (!ret)); i++) {
+    DBG(DBG_PARSING,
+    DBG_log("Trying out: %s", enum_show(&oakley_auth_names, pref[i]));
+    );
+    if ((pref[i]) && (auth[pref[i]])) {
+      ret = TRUE;
+      *ta = auth[pref[i]]->ta;
+      *trans = auth[pref[i]]->trans;
+      *attr_start = alloc_bytes(auth[pref[i]]->attr_len, "attribute");
+      if (*attr_start) {
+	*attr_len = auth[pref[i]]->attr_len;
+	memcpy(*attr_start, auth[pref[i]]->attr_start, *attr_len);
+      }
+      DBG(DBG_PARSING,
+      DBG_log("Candidate selected: %s", 
+        enum_show(&oakley_auth_names, pref[i]));
+      );
+    }
+}
+  
+  for(i=OAKLEY_PRESHARED_KEY; i<=OAKLEY_RSA_ENC_REV; i++) {
+    trans_list_free(&auth[i]);
+  }
+  return ret;
+}
+#endif
+
 /* Parse the body of an ISAKMP SA Payload (i.e. Phase 1 / Main Mode).
  * Various shortcuts are taken.  In particular, the policy, such as
  * it is, is hardwired.
@@ -677,6 +1411,12 @@
     struct isakmp_proposal proposal;
     unsigned no_trans_left;
     int last_transnum;
+    const struct connection *c = st->st_connection;
+    
+#ifdef OPENSSL
+    bool selected;
+    trans_list tl = NULL;
+#endif
 
     /* DOI */
     if (sa->isasa_doi != ISAKMP_DOI_IPSEC)
@@ -764,8 +1504,8 @@
 
     if (selection && proposal.isap_notrans != 1)
     {
-	loglog(RC_LOG_SERIOUS, "a single Transform is required in a selecting Oakley Proposal; found %u",
-	    (unsigned)proposal.isap_notrans);
+	loglog(RC_LOG_SERIOUS, "a single Transform is required in a selecting Oakley Proposal; found %u"
+	    , (unsigned)proposal.isap_notrans);
 	return BAD_PROPOSAL_SYNTAX;
     }
 
@@ -779,14 +1519,11 @@
 	u_char *attr_start;
 	size_t attr_len;
 	struct isakmp_transform trans;
-	lset_t
-	    seen_attrs = 0,
-	    seen_durations = 0;
+	lset_t seen_attrs = 0
+	    , seen_durations = 0;
 	u_int16_t life_type;
 	struct oakley_trans_attrs ta;
-	char ugh[100];	/* mailbox for diagnostics (arbitrary limit) */
-
-	ugh[0] = '\0';	/* empty mailbox */
+	err_t ugh = NULL;       /* set to diagnostic when problem detected */
 
 	/* initialize only optional field in ta */
 	ta.life_seconds = OAKLEY_ISAKMP_SA_LIFETIME_DEFAULT;	/* When this SA expires (seconds) */
@@ -854,10 +1591,10 @@
 			, (unsigned)val, enum_show(&oakley_attr_names, a.isaat_af_type));
 		    return ATTRIBUTES_NOT_SUPPORTED;
 		}
-		DBG(DBG_PARSING,
-		    if ((a.isaat_af_type & ISAKMP_ATTR_AF_MASK) == ISAKMP_ATTR_AF_TV)
-			DBG_log("   [%u is %s]",
-			    (unsigned)val, enum_show(vdesc, val)));
+		DBG(DBG_PARSING
+		    , if ((a.isaat_af_type & ISAKMP_ATTR_AF_MASK) == ISAKMP_ATTR_AF_TV)
+			DBG_log("   [%u is %s]"
+			    , (unsigned)val, enum_show(vdesc, val)));
 	    }
 
 	    switch (a.isaat_af_type)
@@ -865,15 +1602,28 @@
 		case OAKLEY_ENCRYPTION_ALGORITHM | ISAKMP_ATTR_AF_TV:
 		    switch (val)
 		    {
-#if 0	/* we don't feel DES is safe */
 		    case OAKLEY_DES_CBC:
-#endif
+			if ((c->block_cypher == ALL_BLOCK_CYPHER) ||
+			  (c->block_cypher == DES_BLOCK_CYPHER)) {
+			  ta.encrypt = val;
+			  ta.encrypter = &oakley_encrypter[val];
+			} else {
+                       ugh = builddiag("%s is not supported",
+			    enum_show(&oakley_enc_names, val));
+			}
+			break;
 		    case OAKLEY_3DES_CBC:
+			if ((c->block_cypher == ALL_BLOCK_CYPHER) ||
+			  (c->block_cypher == DES3_BLOCK_CYPHER)) {
 			ta.encrypt = val;
 			ta.encrypter = &oakley_encrypter[val];
+			} else {
+                       ugh = builddiag("%s is not supported",
+			    enum_show(&oakley_enc_names, val));
+			}
 			break;
 		    default:
-			snprintf(ugh, sizeof(ugh), "%s is not supported"
+                       ugh = builddiag("%s is not supported"
 			    , enum_show(&oakley_enc_names, val));
 		    }
 		    break;
@@ -887,36 +1637,100 @@
 			ta.hasher = &oakley_hasher[val];
 			break;
 		    default:
-			snprintf(ugh, sizeof(ugh), "%s is not supported",
-			    enum_show(&oakley_hash_names, val));
+                       ugh = builddiag("%s is not supported"
+			    , enum_show(&oakley_hash_names, val));
 		    }
 		    break;
 
 		case OAKLEY_AUTHENTICATION_METHOD | ISAKMP_ATTR_AF_TV:
+                   {
+                   /* check that authentication method is acceptable */
+                   lset_t iap = st->st_policy & POLICY_ID_AUTH_MASK;
+
+                   /* default policy is to accept any method */
+                   if (iap == LEMPTY)
+                       iap = POLICY_ID_AUTH_MASK;
+
 		    switch (val)
 		    {
 		    case OAKLEY_PRESHARED_KEY:
-			/* Accept if policy specifies PSK or is default */
-			if ((st->st_policy & POLICY_PSK)
-			|| (st->st_policy & POLICY_ISAKMP_MASK) == LEMPTY)
+                       if ((iap & POLICY_PSK) == LEMPTY)
 			{
-			    /* check that we can find a preshared secret */
-			    if (get_preshared_secret(st->st_connection) == NULL)
-				snprintf(ugh, sizeof(ugh)
-				    , "Can't authenticate: no preshared key");
-			    ta.auth = val;
+                           ugh = "policy does not allow OAKLEY_PRESHARED_KEY authentication";
 			}
 			else
 			{
-			    snprintf(ugh, sizeof(ugh)
-				, "policy does not allow OAKLEY_PRESHARED_KEY authentication");
+                            /* check that we can find a preshared secret */
+                            struct connection *c = st->st_connection;
+
+                           if (get_preshared_secret(c) == NULL)
+                           {
+                               char mid[IDTOA_BUF]
+                                   , hid[IDTOA_BUF];
+
+                               idtoa(&c->this.id, mid, sizeof(mid));
+                               if (his_id_was_instantiated(c))
+                                   strcpy(hid, "%any");
+                               else
+                                   idtoa(&c->that.id, hid, sizeof(hid));
+                               ugh = builddiag("Can't authenticate: no preshared key found for `%s' and `%s'"
+                                   , mid, hid);
+                           }
+                           ta.auth = val;
 			}
 			break;
 
+#ifdef OPENSSL
+                  case OAKLEY_DSS_SIG:
+                    if ((st->st_connection->key == NULL) ||
+                        (((EVP_PKEY *)(st->st_connection->key))->type != EVP_PKEY_DSA))
+                      ugh = builddiag(
+                      "OAKLEY_DSS_SIG requested, but no DSA key available to sign with. Still unsupported.");
+                    ta.auth = val;
+                    break;
+/*
+ *                case OAKLEY_RSA_SIG:
+ * see after #endif OPENSSL
+ */
+                  case OAKLEY_RSA_ENC:
+                    if (!have_rsa_keypair(st))
+                      ugh = builddiag(
+                      "OAKLEY_RSA_ENC requested, but no cert available to encrypt with");
+                    ta.auth = val;
+                    break;
+                  case OAKLEY_ELGAMAL_ENC:
+                    if (!have_elgamal_keypair(st))
+                      ugh = builddiag(
+                      "OAKLEY_ELGAMAL_ENC requested, but no cert available to encrypt with");
+                    ta.auth = val;
+                    break;
+                  case OAKLEY_RSA_ENC_REV:
+                    if (!have_rsa_keypair(st))
+                      ugh = builddiag(
+                      "OAKLEY_RSA_ENC_REV requested, but no cert available to encrypt with");
+                    ta.auth = val;
+                    break;
+                  case OAKLEY_ELGAMAL_ENC_REV:
+                    if (!have_elgamal_keypair(st))
+                      ugh = builddiag(
+                      "OAKLEY_ELGAMAL_ENC_REV requested, but no cert available to encrypt with");
+                    ta.auth = val;
+                    break;
+
 		    case OAKLEY_RSA_SIG:
+		    if (!use_openssl(st->st_connection))
+		    {
+#endif /* OPENSSL, !use_openssl */
 			/* Accept if policy specifies RSASIG or is default */
-			if ((st->st_policy & POLICY_RSASIG)
-			|| (st->st_policy & POLICY_ISAKMP_MASK) == LEMPTY)
+#ifndef OPENSSL
+                       if ((iap & POLICY_RSASIG) == LEMPTY)
+#else
+                       if ((iap & POLICY_OPENSSL) == LEMPTY)
+#endif
+                       {
+                           ugh = "policy does not allow OAKLEY_RSA_SIG authentication";
+                       }
+                       else
 			{
 			    /* We'd like to check that we can find a public
 			     * key for him and a private key for us that is
@@ -928,26 +1742,30 @@
 			     */
 			    ta.auth = val;
 			}
-			else
-			{
-			    snprintf(ugh, sizeof(ugh)
-				, "policy does not allow OAKLEY_RSA_SIG authentication");
+#ifdef OPENSSL
+		    } else { /* use_openssl */
+		      if ((st->st_connection->key == NULL) ||
+		        (((EVP_PKEY *)(st->st_connection->key))->type != EVP_PKEY_RSA))
+                      ugh = builddiag(
+		      "OAKLEY_RSA_SIG requested, but no key available to sign with");
+		      ta.auth = val;
 			}
+#endif
 			break;
 
 		    default:
-			snprintf(ugh, sizeof(ugh)
-			    , "Pluto does not support %s authentication"
+                       ugh = builddiag("Pluto does not support %s authentication"
 			    , enum_show(&oakley_auth_names, val));
 			break;
 		    }
+		    }
 		    break;
 
 		case OAKLEY_GROUP_DESCRIPTION | ISAKMP_ATTR_AF_TV:
 		    ta.group = lookup_group(val);
 		    if (ta.group == NULL)
 		    {
-			snprintf(ugh, sizeof(ugh), "only OAKLEY_GROUP_MODP1024 and OAKLEY_GROUP_MODP1536 supported");
+                       ugh = "only OAKLEY_GROUP_MODP1024 and OAKLEY_GROUP_MODP1536 supported";
 			break;
 		    }
 		    break;
@@ -969,8 +1787,7 @@
 		case OAKLEY_LIFE_DURATION | ISAKMP_ATTR_AF_TV:
 		    if ((seen_attrs & LELEM(OAKLEY_LIFE_TYPE)) == 0)
 		    {
-			snprintf(ugh, sizeof(ugh),
-			    "OAKLEY_LIFE_DURATION attribute not preceded by OAKLEY_LIFE_TYPE attribute");
+                       ugh = "OAKLEY_LIFE_DURATION attribute not preceded by OAKLEY_LIFE_TYPE attribute";
 			break;
 		    }
 		    seen_attrs &= ~(LELEM(OAKLEY_LIFE_DURATION) | LELEM(OAKLEY_LIFE_TYPE));
@@ -979,8 +1796,7 @@
 		    {
 			case OAKLEY_LIFE_SECONDS:
 			    if (val > OAKLEY_ISAKMP_SA_LIFETIME_MAXIMUM)
-				snprintf(ugh, sizeof(ugh),
-				    "peer requested %lu seconds"
+				ugh = builddiag("peer requested %lu seconds"
 				    " which exceeds our limit %d seconds"
 				    , (long) val
 				    , OAKLEY_ISAKMP_SA_LIFETIME_MAXIMUM);
@@ -1014,11 +1830,11 @@
 		case OAKLEY_GROUP_ORDER | ISAKMP_ATTR_AF_TLV:
 #endif
 		default:
-		    snprintf(ugh, sizeof(ugh), "unsupported OAKLEY attribute");
+                   ugh = "unsupported OAKLEY attribute";
 		    break;
 	    }
 
-	    if (ugh[0] != '\0')
+	    if (ugh != NULL)
 	    {
 		loglog(RC_LOG_SERIOUS, "%s.  Attribute %s"
 		    , ugh, enum_show(&oakley_attr_names, a.isaat_af_type));
@@ -1026,7 +1842,7 @@
 	    }
 	}
 
-	if (ugh[0] == '\0')
+	if (ugh == NULL)
 	{
 	    /* a little more checking is in order */
 	    {
@@ -1049,8 +1865,9 @@
 	     * Lets finish early and leave.
 	     */
 
-	    DBG(DBG_PARSING | DBG_CRYPT,
-		DBG_log("Oakley Transform %u accepted", trans.isat_transnum));
+#ifndef OPENSSL
+	    DBG(DBG_PARSING | DBG_CRYPT
+		, DBG_log("Oakley Transform %u accepted", trans.isat_transnum));
 
 	    if (r_sa_pbs != NULL)
 	    {
@@ -1087,6 +1904,7 @@
 		if (!out_struct(&r_trans, &isakmp_isakmp_transform_desc, &r_proposal_pbs, &r_trans_pbs))
 		    passert(FALSE);
 
+
 		if (!out_raw(attr_start, attr_len, &r_trans_pbs, "attributes"))
 		    passert(FALSE);
 		close_output_pbs(&r_trans_pbs);
@@ -1102,6 +1920,14 @@
 	    /* copy over the results */
 	    st->st_oakley = ta;
 	    return NOTHING_WRONG;
+#else
+	    /*
+	     * We store the ta result into the list of candidates
+	     * Afterwards, site policy dictates which of the
+	     * candidates we should select
+	     */
+	    trans_list_append(&tl, &ta, &trans, attr_start, attr_len);
+#endif
 	}
 
 	/* on to next transform */
@@ -1122,9 +1948,77 @@
 		, enum_show(&payload_names, proposal.isap_np));
 	    return BAD_PROPOSAL_SYNTAX;
 	}
-    }
+    } /* for */
+
+#ifndef OPENSSL
     loglog(RC_LOG_SERIOUS, "no acceptable Oakley Transform");
     return NO_PROPOSAL_CHOSEN;
+#else
+    /* We should have a list of hopefuls in the list tl */
+    { /* open scope */
+      u_char *attr_start;
+      size_t attr_len;
+      struct isakmp_transform trans;
+
+      selected = select_trans_candidate(tl, &st->st_oakley, &trans, 
+        &attr_start, &attr_len, st->st_connection->cert_options);
+      trans_list_free(&tl);
+      if (! selected) {
+        log("no acceptable Oakley Transform");
+        return NO_PROPOSAL_CHOSEN;
+      } else {
+        DBG(DBG_PARSING | DBG_CRYPT,
+        DBG_log("Oakley Transform %u accepted", trans.isat_transnum)
+        );
+
+        if (r_sa_pbs != NULL)
+        {
+          struct isakmp_proposal r_proposal = proposal;
+          pb_stream r_proposal_pbs;
+          struct isakmp_transform r_trans = trans;
+          pb_stream r_trans_pbs;
+
+          /* Situation */
+          if (!out_struct(&ipsecdoisit, &ipsec_sit_desc, r_sa_pbs, NULL))
+            passert(FALSE);
+
+          /* Proposal */
+#ifdef EMIT_ISAKMP_SPI
+          r_proposal.isap_spisize = COOKIE_SIZE;
+#else
+          r_proposal.isap_spisize = 0;
+#endif
+          r_proposal.isap_notrans = 1;
+          if (!out_struct(&r_proposal, &isakmp_proposal_desc, r_sa_pbs, &r_proposal_pbs))
+            passert(FALSE);
+
+          /* SPI */
+#ifdef EMIT_ISAKMP_SPI
+          if (!out_raw(my_cookie, COOKIE_SIZE, &r_proposal_pbs, "SPI"))
+            passert(FALSE);
+          r_proposal.isap_spisize = COOKIE_SIZE;
+#else
+          /* none (0) */
+#endif
+
+          /* Transform */
+          r_trans.isat_np = ISAKMP_NEXT_NONE;
+          if (!out_struct(&r_trans, &isakmp_isakmp_transform_desc, 
+            &r_proposal_pbs, &r_trans_pbs))
+            passert(FALSE);
+
+          if (!out_raw(attr_start, attr_len, &r_trans_pbs, "attributes"))
+            passert(FALSE);
+          if (attr_start) pfree(attr_start);
+
+          close_output_pbs(&r_trans_pbs);
+          close_output_pbs(&r_proposal_pbs);
+          close_output_pbs(r_sa_pbs);
+        }     /* if (r_sa_pbs != NULL) */
+      return NOTHING_WRONG;
+      }       /* if (! selected) */
+    }  /* end this scope */
+#endif        /* OPENSSL */
 }
 
 /* Parse the body of an IPsec SA Payload (i.e. Phase 2 / Quick Mode).
@@ -1175,9 +2069,8 @@
 , bool is_ipcomp
 , struct state *st)	/* current state object */
 {
-    lset_t
-	seen_attrs = 0,
-	seen_durations = 0;
+    lset_t seen_attrs = 0
+       , seen_durations = 0;
     u_int16_t life_type;
     const struct oakley_group_desc *pfs_group = NULL;
 
@@ -1249,10 +2142,10 @@
 		    , (unsigned)val, enum_show(&ipsec_attr_names, a.isaat_af_type));
 		return FALSE;
 	    }
-	    DBG(DBG_PARSING,
-		if ((a.isaat_af_type & ISAKMP_ATTR_AF_MASK) == ISAKMP_ATTR_AF_TV)
-		    DBG_log("   [%u is %s]",
-			(unsigned)val, enum_show(vdesc, val)));
+	    DBG(DBG_PARSING
+		, if ((a.isaat_af_type & ISAKMP_ATTR_AF_MASK) == ISAKMP_ATTR_AF_TV)
+		    DBG_log("   [%u is %s]"
+			, (unsigned)val, enum_show(vdesc, val)));
 	}
 
 	switch (a.isaat_af_type)
@@ -1553,7 +2446,7 @@
 		/* We store CPI in the low order of a network order
 		 * ipsec_spi_t.  So we start a couple of bytes in.
 		 */
-		memset(&next_spi, '\0', sizeof(next_spi));
+		zero(&next_spi);
 		if (!in_raw((u_char *)&next_spi
 		  + IPSEC_DOI_SPI_SIZE - IPCOMP_CPI_SIZE
 		, IPCOMP_CPI_SIZE, &next_proposal_pbs, "CPI"))
@@ -1759,8 +2652,8 @@
 		}
 		if (!ok_auth)
 		{
-		    DBG(DBG_CONTROL | DBG_CRYPT,
-			DBG_log("%s attribute unsupported"
+		    DBG(DBG_CONTROL | DBG_CRYPT
+			, DBG_log("%s attribute unsupported"
 			    " in %s Transform from %s"
 			    , enum_name(&auth_alg_names, ah_attrs.auth)
 			    , enum_show(&ah_transformid_names, ah_attrs.transid)
@@ -1797,9 +2690,7 @@
 
 		switch (esp_attrs.transid)
 		{
-#if 0	/* we don't feel single DES is safe */
 		    case ESP_DES:
-#endif
 		    case ESP_3DES:
 			break;
 
@@ -1812,8 +2703,8 @@
 			}
 			if (st->st_policy & POLICY_ENCRYPT)
 			{
-			    DBG(DBG_CONTROL | DBG_CRYPT,
-				    DBG_log("ESP_NULL Transform Proposal from %s"
+			    DBG(DBG_CONTROL | DBG_CRYPT
+				    , DBG_log("ESP_NULL Transform Proposal from %s"
 					" does not satisfy POLICY_ENCRYPT"
 					, ip_str(&c->that.host_addr)));
 			    continue;   /* try another */
@@ -1854,8 +2745,8 @@
 		if (ah_seen && ah_attrs.encapsulation != esp_attrs.encapsulation)
 		{
 		    /* ??? This should be an error, but is it? */
-		    DBG(DBG_CONTROL | DBG_CRYPT,
-			DBG_log("AH and ESP transforms disagree about encapsulation; TUNNEL presumed"));
+		    DBG(DBG_CONTROL | DBG_CRYPT
+			, DBG_log("AH and ESP transforms disagree about encapsulation; TUNNEL presumed"));
 		}
 
 		break;	/* we seem to be happy */
@@ -1946,13 +2837,13 @@
 		if (ah_seen && ah_attrs.encapsulation != ipcomp_attrs.encapsulation)
 		{
 		    /* ??? This should be an error, but is it? */
-		    DBG(DBG_CONTROL | DBG_CRYPT,
-			DBG_log("AH and IPCOMP transforms disagree about encapsulation; TUNNEL presumed"));
+		    DBG(DBG_CONTROL | DBG_CRYPT
+			, DBG_log("AH and IPCOMP transforms disagree about encapsulation; TUNNEL presumed"));
 		} else if (esp_seen && esp_attrs.encapsulation != ipcomp_attrs.encapsulation)
 		{
 		    /* ??? This should be an error, but is it? */
-		    DBG(DBG_CONTROL | DBG_CRYPT,
-			DBG_log("ESP and IPCOMP transforms disagree about encapsulation; TUNNEL presumed"));
+		    DBG(DBG_CONTROL | DBG_CRYPT
+			, DBG_log("ESP and IPCOMP transforms disagree about encapsulation; TUNNEL presumed"));
 		}
 
 		break;	/* we seem to be happy */
@@ -1974,33 +2865,33 @@
 
 	    /* AH proposal */
 	    if (ah_seen)
-		echo_proposal(ah_proposal,
-		    ah_trans,
-		    esp_seen || ipcomp_seen? ISAKMP_NEXT_P : ISAKMP_NEXT_NONE,
-		    r_sa_pbs,
-		    &st->st_ah,
-		    &isakmp_ah_transform_desc,
-		    &ah_trans_pbs);
+		echo_proposal(ah_proposal
+		    , ah_trans
+		    , esp_seen || ipcomp_seen? ISAKMP_NEXT_P : ISAKMP_NEXT_NONE
+		    , r_sa_pbs
+		    , &st->st_ah
+		    , &isakmp_ah_transform_desc
+		    , &ah_trans_pbs);
 
 	    /* ESP proposal */
 	    if (esp_seen)
-		echo_proposal(esp_proposal,
-		    esp_trans,
-		    ipcomp_seen? ISAKMP_NEXT_P : ISAKMP_NEXT_NONE,
-		    r_sa_pbs,
-		    &st->st_esp,
-		    &isakmp_esp_transform_desc,
-		    &esp_trans_pbs);
+		echo_proposal(esp_proposal
+		    , esp_trans
+		    , ipcomp_seen? ISAKMP_NEXT_P : ISAKMP_NEXT_NONE
+		    , r_sa_pbs
+		    , &st->st_esp
+		    , &isakmp_esp_transform_desc
+		    , &esp_trans_pbs);
 
 	    /* IPCOMP proposal */
 	    if (ipcomp_seen)
-		echo_proposal(ipcomp_proposal,
-		    ipcomp_trans,
-		    ISAKMP_NEXT_NONE,
-		    r_sa_pbs,
-		    &st->st_ipcomp,
-		    &isakmp_ipcomp_transform_desc,
-		    &ipcomp_trans_pbs);
+		echo_proposal(ipcomp_proposal
+		    , ipcomp_trans
+		    , ISAKMP_NEXT_NONE
+		    , r_sa_pbs
+		    , &st->st_ipcomp
+		    , &isakmp_ipcomp_transform_desc
+		    , &ipcomp_trans_pbs);
 
 	    close_output_pbs(r_sa_pbs);
 	}
diff -bruN freeswan-1.9.orig/pluto/spdb.h freeswan-1.9/pluto/spdb.h
--- freeswan-1.9.orig/pluto/spdb.h	Fri Sep 15 05:09:28 2000
+++ freeswan-1.9/pluto/spdb.h	Wed May 16 10:57:20 2001
@@ -24,11 +24,32 @@
     u_int16_t val;
 };
 
+#ifdef OPENSSL
+typedef bool offer_fn(struct state *st);
+/* Addition for OpenSSL: we don't want to offer cipher suites */
+/* which we aren't capable of generating, so I added a function */
+/* parameter 'offer', which takes the state as a parameter, and */
+/* returns either TRUE or FALSE, depending on whether the cipher */
+/* suite is supportable. For instance, there's no point in */
+/* offering to sign things with a DSA signature key, if all you've */
+/* got is an RSA one. */
+/* NB: If the function pointer is set to NULL, it means offer the */
+/* cipher suite under all conditions. The downside to this is that */
+/* another parameter must be added to all the IPsec cipher transforms */
+/* which is always NULL. I suppose we could embed policy information */
+/* within that parameter, e.g. If a pair of endpoints must have */
+/* a particular cipher between them. Trouble is, that information is */
+/* present within ipsec.conf, to some extent -- nd */
+#endif
+
 /* transform */
 struct db_trans {
     u_int8_t transid;	/* Transform-Id */
     struct db_attr *attrs;	/* array */
     int attr_cnt;	/* number of elements */
+#ifdef OPENSSL
+    offer_fn *offer;
+#endif
 };
 
 /* proposal */
@@ -56,9 +77,12 @@
 };
 
 /* The oakley sadb is subscripted by a bitset with members
- * from POLICY_PSK and POLICY_RSASIG.
+ * from POLICY_PSK and POLICY_RSASIG/OPENSSL.
  */
 extern struct db_sa oakley_sadb[1 << 2];
+#ifdef OPENSSL
+extern struct db_sa oakley_sadb2[1 << 2];
+#endif
 
 /* The ipsec sadb is subscripted by a bitset with members
  * from POLICY_ENCRYPT, POLICY_AUTHENTICATE, POLICY_COMPRESS
diff -bruN freeswan-1.9.orig/pluto/state.c freeswan-1.9/pluto/state.c
--- freeswan-1.9.orig/pluto/state.c	Tue Jan 30 16:58:36 2001
+++ freeswan-1.9/pluto/state.c	Thu Jun  7 14:47:11 2001
@@ -12,7 +12,7 @@
  * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
  * for more details.
  *
- * RCSID $Id: state.c,v 1.77 2001/01/30 21:58:36 dhr Exp $
+ * RCSID $Id: state.c,v 1.81 2001/05/08 05:37:24 dhr Exp $
  */
 
 #include <stdio.h>
@@ -162,12 +162,13 @@
 struct state *
 new_state(void)
 {
-    static struct state blank_state;	/* initialized all to zero & NULL */
+    static const struct state blank_state;     /* initialized all to zero & NULL */
+    static so_serial_t next_so = SOS_FIRST;
     struct state *st;
 
-    blank_state.st_serialno++;
-    passert(blank_state.st_serialno != SOS_NOBODY);	/* overflow can't happen! */
     st = clone_thing(blank_state, "struct state in new_state()");
+    st->st_serialno = next_so++;
+    passert(next_so > SOS_FIRST);      /* overflow can't happen! */
     st->st_whack_sock = NULL_FD;
     DBG(DBG_CONTROL, DBG_log("creating state object #%lu at %p",
 	st->st_serialno, (void *) st));
@@ -196,6 +197,8 @@
 struct state *
 state_with_serialno(so_serial_t sn)
 {
+    if (sn >= SOS_FIRST)
+    {
     struct state *st;
     int i;
 
@@ -203,6 +206,7 @@
 	for (st = statetable[i]; st != NULL; st = st->st_hashchain_next)
 	    if (st->st_serialno == sn)
 		return st;
+    }
     return NULL;
 }
 
@@ -291,6 +295,13 @@
 #endif
     passert(st->st_event == NULL);
 
+    /* Ditch anything pending on ISAKMP SA being established.
+     * Note: this must be done before the unhash_state to prevent
+     * flush_pending_by_state inadvertently and prematurely
+     * deleting our connection.
+     */
+    flush_pending_by_state(st);
+
     /* effectively, this deletes any ISAKMP SA that this state represents */
     unhash_state(st);
 
@@ -348,31 +359,34 @@
     pfreeany(st->st_esp.our_keymat);
     pfreeany(st->st_esp.peer_keymat);
 
+#ifdef OPENSSL
+    /* Clean out the stuff for revised PK encryption mode */
+    pfreeany(st->st_ne_i.ptr);
+    memset(&st->st_ks_i, 0, sizeof(st->st_ks_i));
+    memset(st->st_ne_i_iv, 0, MAX_DIGEST_LEN);
+    pfreeany(st->st_ne_r.ptr);
+    memset(&st->st_ks_r, 0, sizeof(st->st_ks_r));
+    memset(st->st_ne_r_iv, 0, MAX_DIGEST_LEN);
+#endif
+
     pfree(st);
 }
 
 
-/* If a connection will no longer be used, and it is temporary, delete it.
- * We must be careful to avoid circularity:
- * we don't touch it if it is rwcs_going_away.
- */
-void
-connection_discard(struct connection *c)
+/* Is a connection in use by some state? */
+bool
+states_use_connection(struct connection *c)
 {
-    if (c->rw_state == rwcs_instance)
-    {
 	/* are there any states still using it? */
 	struct state *st = NULL;
 	int i;
 
 	for (i = 0; st == NULL && i < STATE_TABLE_SIZE; i++)
-	    for (st = statetable[i]
-	    ; st != NULL && st->st_connection != c
-	    ; st = st->st_hashchain_next)
-		;
-	if (st == NULL)
-	    delete_connection(c);
-    }
+       for (st = statetable[i]; st != NULL; st = st->st_hashchain_next)
+           if (st->st_connection == c)
+               return TRUE;
+
+    return FALSE;
 }
 
 void
@@ -381,10 +395,10 @@
     int i;
 
     /* this kludge avoids an n^2 algorithm */
-    enum rwcs rws = c->rw_state;
+    enum connection_kind ck = c->kind;
 
-    if (rws == rwcs_instance)
-	c->rw_state = rwcs_going_away;
+    if (ck == CK_INSTANCE)
+       c->kind = CK_GOING_AWAY;
 
     for (i = 0; i < STATE_TABLE_SIZE; i++)
     {
@@ -421,9 +435,9 @@
 	}
     }
 
-    if (rws == rwcs_instance)
+    if (ck == CK_INSTANCE)
     {
-	c->rw_state = rws;
+	c->kind = ck;
 	delete_connection(c);
     }
 }
@@ -495,9 +509,10 @@
     return st;
 }
 
-/* Find newest ISAKMP SA state object that implements connection c */
+/* Find newest Phase 1 negotiation state object for suitable for connection c
+ */
 struct state *
-find_isakmp_sa(const struct connection *c)
+find_phase1_state(const struct connection *c)
 {
     struct state
 	*st,
@@ -506,7 +521,7 @@
 
     for (i = 0; i < STATE_TABLE_SIZE; i++)
 	for (st = statetable[i]; st != NULL; st = st->st_hashchain_next)
-	    if (IS_ISAKMP_SA_ESTABLISHED(st->st_state)
+	    if (IS_PHASE1(st->st_state)
 	    && c->host_pair == st->st_connection->host_pair
 	    && same_peer_ids(c, st->st_connection, NULL)
 	    && (best == NULL || best->st_serialno < st->st_serialno))
@@ -543,7 +558,7 @@
 	    passert(st->st_event != 0);
 
 	    him[0] = '\0';
-	    if (c->rw_state == rwcs_instance)
+	    if (c->kind == CK_INSTANCE)
 	    {
 		him[0] = ':';
 		addrtot(&c->that.host_addr, 0, him+1, sizeof(him)-1);
